Web/FishMap.Web/Controllers/CommentsController.cs
namespace FishMap.Web.Controllers
{
    using System.Threading.Tasks;

    using FishMap.Data.Models;
    using FishMap.Services.Data.Contracts;
    using FishMap.Web.ViewModels.Comments;
    using Microsoft.AspNetCore.Authorization;
    using Microsoft.AspNetCore.Identity;
    using Microsoft.AspNetCore.Mvc;

    [Authorize]
    public class CommentsController : Controller
    {
        private readonly ICommentService commentService;
        private readonly UserManager<ApplicationUser> userManager;

        public CommentsController(
            ICommentService commentService,
            UserManager<ApplicationUser> userManager)
        {
            this.commentService = commentService;
            this.userManager = userManager;
        }

        [HttpPost]
        public async Task<IActionResult> MakeInTrip(MakeCommentTripInputModel input)
        {
            var user = await this.userManager.GetUserAsync(this.User);
            await this.commentService.CreateForTrip(input.TripId, input.Content, user.Id);
            return this.RedirectToAction(nameof(TripsController.ById), nameof(TripsController).Replace("Controller", string.Empty), new { id = input.TripId });
        }

        [HttpPost]
        public async Task<IActionResult> MakeInGroupTrip(MakeCommentGrouptripInputModel input)
        {
            var user = await this.userManager.GetUserAsync(this.User);
            await this.commentService.CreateForGroupTrip(input.GroupTripId, input.Content, user.Id);
            return this.RedirectToAction(nameof(TripsController.ById), nameof(GroupTripsController).Replace("Controller", string.Empty), new { id = input.GroupTripId });
        }
    }
}

Web/FishMap.Web/Controllers/TripsController.cs
namespace FishMap.Web.Controllers
{
    using System.Threading.Tasks;

    using FishMap.Common;
    using FishMap.Data.Models;
    using FishMap.Services.Data.Contracts;
    using FishMap.Web.ViewModels.Trips;
    using Microsoft.AspNetCore.Authorization;
    using Microsoft.AspNetCore.Identity;
    using Microsoft.AspNetCore.Mvc;

    [Authorize]
    public class TripsController : BaseController
    {
        private readonly ITripsService tripService;
        private readonly UserManager<ApplicationUser> userManager;

        public TripsController(
            ITripsService tripService,
            UserManager<ApplicationUser> userManager)
        {
            this.tripService = tripService;
            this.userManager = userManager;
        }

        public IActionResult Create()
        {
            return this.View();
        }

        [HttpPost]
        public async Task<IActionResult> Create(CreateTripInputModel input)
        {
            if (!this.ModelState.IsValid)
            {
                return this.View();
            }

            var user = await this.userManager.GetUserAsync(this.User);
            var tripToFishData = await this.tripService.CreateAsync(input, user.Id);

            return this.RedirectToAction(nameof(FishController.Create), nameof(FishController).Replace("Controller", string.Empty), tripToFishData);
        }

        public IActionResult All(int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new TripListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.tripService.GetAllCount(),
                Trips = this.tripService.GetAllForPaging(id, itemsPerPage),
            };

            return this.View(viewModel);
        }

        public async Task<IActionResult> ById(int id)
        {
            var viewModel = this.tripService.GetById(id);

            if (viewModel == null)
            {
                return this.NotFound();
            }

            var user = await this.userManager.GetUserAsync(this.User);
            viewModel.IsUserAdmin = await this.userManager.IsInRoleAsync(user, GlobalConstants.AdministratorRoleName);
            viewModel.IsUserCreator = this.tripService.IsUserCreator(user.Id, id);

            return this.View(viewModel);
        }

        public IActionResult OrderBy(string order, int id = 1)
        {
            if (id <= 0)
            {
                return this.NotFound();
            }

            const int itemsPerPage = 9;

            var viewModel = new TripListViewModel
            {
                ItemsPerPage = itemsPerPage,
                PageNumber = id,
                ItemsCount = this.tripService.GetAllCount(),
            };

            switch (order)
            {
                case "CreatedOnDesc":
                    viewModel.Trips = this.tripService.OrderAllByCreatedOnDesc(id, itemsPerPage);
                    break;
                case "CreatedOnAsc":
                    viewModel.Trips = this.tripService.OrderAllByCreatedOnAsc(id, itemsPerPage);
                    break;
                case "TripDateDesc":
                    viewModel.Trips = this.tripService.OrderAllByTripDateDesc(id, itemsPerPage);
                    break;
                case "TripDateAsc":
                    viewModel.Trips = this.tripService.OrderAllByTripDateAsc(id, itemsPerPage);
                    break;
                default:
                    return this.NotFound();
            }

            return this.View(viewModel);
        }

        public async Task<IActionResult> Delete(int id)
        {
            var user = await this.userManager.GetUserAsync(this.User);

            if (!this.User.IsInRole(GlobalConstants.AdministratorRoleName)
                && !this.tripService.IsUserCreator(user.Id, id))
            {
                return this.Unauthorized();
            }

            try
            {
                await this.tripService.Delete(id);
            }
            catch (System.NullReferenceException)
            {
                return this.NotFound();
            }

            return this.RedirectToAction(nameof(this.All));
        }
    }
}

Web/FishMap.Web/Views/Trips/All.cshtml
@model FishMap.Web.ViewModels.Trips.TripListViewModel
@{
    ViewData["Title"] = "Излети";
}

<h1 class="h2 text-center mt-3">@ViewData["Title"]</h1>
<hr class="alert-info" />
<div class="container">
    <partial name="_OrderByDropdownPartial" />
    <div class="row">
        @foreach (var trip in Model.Trips)
        {
            <div class="card col-md-4">
                <img class="img-thumbnail mt-3" src="@trip.ImageUrl" alt="Card image">
                <div class="card-body">
                    <h5 class="card-title text-justify">@trip.WaterPoolName</h5>
                    <p class="card-text"><strong>Област: </strong>@trip.NearestTownName</p>
                    <p class="card-text"><strong>Рибар: </strong>@trip.Username</p>
                    <p class="card-text"><strong>Дата: </strong>@trip.Date</p>
                    <p class="card-text"><strong>Видове хванати риби: </strong>@string.Join(", ", trip.CaughtFishSpecies.Distinct())</p>
                    <p class="card-text"><strong>Брой хванати риби: </strong>@trip.FishCaughtCount</p>
                </div>
                <div class="card-footer bg-dark border-white">
                    <a asp-action="ById" asp-route-id="@trip.Id" class="btn btn-primary">Повече информация</a>
                </div>
            </div>
        }
    </div>
</div>
<hr class="alert-info" />
<partial name="_PagingPartial" model="@Model" />
<br>

Web/FishMap.Web/Views/Trips/ById.cshtml
@using Microsoft.Extensions.Configuration
@using FishMap.Services
@inject IFishingMethodService fishingmethodService
@inject IConfiguration configuration
@model FishMap.Web.ViewModels.Trips.TripByIdViewModel
@{
    ViewData["Title"] = "ById";
}


<div class="container">
    <div class="row mt-4">
        <div class="col-md-8">
            <div id="map" class="z-depth-1-half map-responsive rounded img-thumbnail" style="height: 45vh"></div>
        </div>
        <div class="col-md-4 align-self-center">
            <ul class="list-group">
                <li class="list-group-item"><strong>Име на воден басейн: </strong>@Model.WaterPoolName</li>
                <li class="list-group-item"><strong>Рибар: </strong>@Model.Username</li>
                <li class="list-group-item"><strong>Дата: </strong>@Model.Date</li>
                <li class="list-group-item"><strong>Метод на риболов: </strong>@fishingmethodService.TranslateFishingmethod(Model.FishingMethod)</li>
                <li class="list-group-item"><strong>Описание: </strong>@Model.Description</li>
            </ul>
            @if (Model.IsUserCreator || Model.IsUserAdmin)
            {
                <div class="d-flex flex-row-reverse mt-3">
                    <a asp-action="Delete" asp-route-id="@Model.Id" class="btn btn-danger">Изтрий</a>
                </div>
            }
        </div>
    </div>
    <hr class="alert-info" />
    <div class="row mt-3">
        <table class="table table-striped table-dark text-center table-responsive-sm">
            <thead>
                <tr>
                    <th scope="col">Вид</th>
                    <th scope="col">Дължина (см.)</th>
                    <th scope="col">Тегло (кг.)</th>
                    <th scope="col">Снимки</th>
                </tr>
            </thead>
            <tbody>
                @for (int i = 0; i < Model.Fish.Count(); i++)
                {
                    <tr>
                        <td>@Model.Fish.ElementAt(i).FishSpecies</td>
                        <td>@Model.Fish.ElementAt(i).Length</td>
                        <td>@(String.Format("{0:0.000}", Model.Fish.ElementAt(i).Weight))</td>
                        <td>
                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="@("#exampleModal" + i.ToString())">
                                Виж снимки
                            </button>
                            <div class="modal fade" id="@("exampleModal" + i.ToString())" tabindex="-1" role="dialog" aria-labelledby="@("#exampleModalLabel" + i.ToString())" aria-hidden="true">
                                <div class="modal-dialog" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <h5 class="modal-title" id="@("exampleModalLabel" + i.ToString())">Снимки</h5>
                                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">&times;</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">
                                            <div id="@("carouselExampleControls" + i.ToString())" class="carousel slide" data-ride="carousel">
                                                <div class="carousel-inner">
                                                    @for (int y = 0; y < Model.Fish.ElementAt(i).ImagesUrls.Count(); y++)
                                                    {
                                                        if (y == 0)
                                                        {
                                                            <div class="carousel-item active">
                                                                <img class="d-block w-100" src="@Model.Fish.ElementAt(i).ImagesUrls.ElementAt(y)" alt="Image">
                                                            </div>
                                                        }
                                                        else
                                                        {
                                                            <div class="carousel-item">
                                                                <img class="d-block w-100" src="@Model.Fish.ElementAt(i).ImagesUrls.ElementAt(y)" alt="Image">
                                                            </div>
                                                        }
                                                    }
                                                </div>
                                                <a class="carousel-control-prev" href="@("#carouselExampleControls" + i.ToString())" role="button" data-slide="prev">
                                                    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                                                    <span class="sr-only">Previous</span>
                                                </a>
                                                <a class="carousel-control-next" href="@("#carouselExampleControls" + i.ToString())" role="button" data-slide="next">
                                                    <span class="carousel-control-next-icon" aria-hidden="true"></span>
                                                    <span class="sr-only">Next</span>
                                                </a>
                                            </div>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Затвори</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <hr class="alert-info mt-0 mb-0" />
    <div class="row mt-2">
            <h3>Коментари:</h3>
    </div>
    <div class="row mt-3" id="commentsDiv">
        <table class="table table-dark table-responsive-sm table-striped">
            <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Потребител:</th>
                    <th scope="col">Коментар</th>
                    <th scope="col">Дата: </th>
                </tr>
            </thead>
            <tbody>
                @for (int i = 0; i < Model.Comments.Count(); i++)
                {
                    <tr>
                        <th scope="row">@(i + 1)</th>
                        <td>@Model.Comments.ElementAt(i).AddedByUsername</td>
                        <td>@Model.Comments.ElementAt(i).Content</td>
                        <td>@Model.Comments.ElementAt(i).CreatedOnString</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <div id="makeCommentDiv">
        <form asp-controller="Comments" asp-action="MakeInTrip" method="post" class="row mb-5">
            <input type="hidden" id="TripId" name="TripId" value="@Model.Id" />
            <div class="form-group col-md-10">
                <label for="Content"></label>
                <textarea name="Content" id="Content" class="w-100 form-control"></textarea>
            </div>
            <div class="col-md-2 align-self-center">
                <input type="submit" class="btn btn-lg btn-success" value="+ Kоментар"/>
            </div>
        </form>
    </div>
</div>

@section Scripts{
    <script src="https://maps.googleapis.com/maps/api/js?key=@(this.configuration["GoogleMaps:ApiKey"])&callback=initMap&libraries=&v=weekly"
            defer></script>
    <script>
        let markers = [];
        let map;

        function initMap() {
            const location = { lat: @Model.LocationLatitude, lng: @Model.LoacationLongtitude };

            map = new google.maps.Map(document.getElementById("map"), {
                zoom: 12,
                center: location,
            });

            const marker = new google.maps.Marker({
                icon: "http://maps.google.com/mapfiles/kml/shapes/fishing.png",
                draggable: false,
                optimized: true,
                animation: google.maps.Animation.DROP,
                map: map,
                position: location,
            });

            markers.push(marker);
        }
    </script>
}

Web/FishMap.Web/Views/Trips/Create.cshtml
@using Microsoft.Extensions.Configuration
@inject IConfiguration configuration
@model FishMap.Web.ViewModels.Trips.CreateTripInputModel
@{
    this.ViewData["Title"] = "Добавяне на риболовен излет";
}
<div class="pb-4 ">
    <h1 class="text-center pt-3">@this.ViewData["Title"]</h1>
    <hr class="alert-info" />
    <form class="row mb-5 mb-md-0 pb-0 pb-md-5" method="post">
        <div class="col-md-6">
            <div class="form-group">
                <label asp-for="WaterPoolName"></label>
                <input type="text" asp-for="WaterPoolName" class="form-control" />
                <span asp-validation-for="WaterPoolName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="FishCaughtCout"></label>
                <input type="number" min="0" max="100" asp-for="FishCaughtCout" class="form-control" />
                <span asp-validation-for="FishCaughtCout" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description"></label>
                <textarea asp-for="Description" rows="5" class="form-control"></textarea>
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Date"></label>
                <input type="date" asp-for="Date" class="form-control" />
                <span asp-validation-for="Date" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="FishingMethod"></label>
                <select asp-for="FishingMethod" class="form-control"
                        asp-items="Html.GetEnumSelectList<FishMap.Data.Models.FishingMethodEnum>()">
                    <option>Избери метод на риболов...</option>
                </select>
                <span asp-validation-for="FishingMethod" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input id="latitude" type="hidden" asp-for="LocationLatitude" class="form-control" />
                <span asp-validation-for="LocationLatitude" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input id="longtitude" type="hidden" asp-for="LocationLongtitude" class="form-control" />
                <span asp-validation-for="LocationLongtitude" class="text-danger"></span>
            </div>
        </div>
        <div class="col-md-6">
            <div class="form-group mt-md-6">
                <label>Изберете място на излета</label>
                <div id="map" class="z-depth-1-half map-responsive" style="height: 63vh"></div>
            </div>
        </div>
        <div class="col-12 text-center">
            <hr class="alert-info" />
            <button type="submit" class="btn btn-success">Добавяне на риби към излета</button>
        </div>
    </form>
</div>

@section Scripts{
    <script src="https://maps.googleapis.com/maps/api/js?key=@(this.configuration["GoogleMaps:ApiKey"])&callback=initMap&libraries=&v=weekly"
            defer></script>
    <script>
        let markers = [];
        let map;

        function initMap() {
            const myLatlng = { lat: 42.7249925, lng: 25.4833039 };
            map = new google.maps.Map(document.getElementById("map"), {
                zoom: 7.5,
                center: myLatlng,
            });

            map.addListener("click", (event) => {
                deleteMarkers();
                addMarker(event.latLng);
                const coordinatesJson = event.latLng.toJSON()
                console.log(coordinatesJson);
                fillLocationCoordinates(coordinatesJson);
            });
        }

        function addMarker(location) {
            const marker = new google.maps.Marker({
                icon: "http://maps.google.com/mapfiles/kml/shapes/fishing.png",
                draggable: false,
                animation: google.maps.Animation.DROP,
                map: map,
                position: location,
            });
            markers.push(marker);
        }

        function deleteMarkers() {
            clearMarkers();
            markers = [];
        }

        function clearMarkers() {
            setMapOnAll(null);
        }

        function setMapOnAll(map) {
            for (let i = 0; i < markers.length; i++) {
                markers[i].setMap(map);
            }
        }

        function fillLocationCoordinates(latLng) {
            document.getElementById('latitude').value = latLng.lat;
            document.getElementById('longtitude').value = latLng.lng;
        }
    </script>
}

Web/FishMap.Web/Views/Trips/OrderBy.cshtml
@model FishMap.Web.ViewModels.Trips.TripListViewModel
@{
    ViewData["Title"] = "Излети";
}

<h1 class="h2 text-center mt-3">@ViewData["Title"]</h1>
<hr class="alert-info" />
<div class="container">
    <partial name="_OrderByDropdownPartial" />
    <div class="row">
        @foreach (var trip in Model.Trips)
        {
            <div class="card col-md-4">
                <img class="img-thumbnail mt-3" src="@trip.ImageUrl" alt="Card image cap">
                <div class="card-body">
                    <h5 class="card-title text-justify">@trip.WaterPoolName</h5>
                    <p class="card-text"><strong>Област: </strong>@trip.NearestTownName</p>
                    <p class="card-text"><strong>Рибар: </strong>@trip.Username</p>
                    <p class="card-text"><strong>Дата: </strong>@trip.Date</p>
                    <p class="card-text"><strong>Видове хванати риби: </strong>@string.Join(", ", trip.CaughtFishSpecies.Distinct())</p>
                    <p class="card-text"><strong>Брой хванати риби: </strong>@trip.FishCaughtCount</p>
                </div>
                <div class="card-footer bg-dark border-white">
                    <a asp-action="ById" asp-route-id="@trip.Id" class="btn btn-primary">Повече информация</a>
                </div>
            </div>
        }
    </div>
</div>
<hr class="alert-info" />
<partial name="_PagingPartial" model="@Model" />
<br>